Index: /branches/2.2/expressoMail1_2/js/local_messages.js
===================================================================
--- /branches/2.2/expressoMail1_2/js/local_messages.js	(revision 3269)
+++ /branches/2.2/expressoMail1_2/js/local_messages.js	(revision 3286)
@@ -3,310 +3,326 @@
  */
 
-	function local_messages() {
-		this.dbGears = null;
-		this.localServer = null;
-		this.store = null;
-	}
-
-        function HeaderFlags()
-        {
-            this.Answered = 0;
-            //this.Draft = 0;
-            this.Flagged = 0;
-            this.Recent = 0;
-        }
-
-        HeaderFlags.prototype.getAnswered = function()
-        {
-            return this.Answered;
-        }
-
-        HeaderFlags.prototype.setAnswered = function(answered)
-        {
-            this.Answered = answered;
-        }
-
-        //HeaderFlags.prototype.getDraft = function()
-        //{
-        //    return this.Draft;
-        //}
-
-        HeaderFlags.prototype.setDraft = function(draft)
-        {
-            this.Draft = draft;
-        }
-
-        HeaderFlags.prototype.getFlagged = function()
-        {
-            return this.Flagged;
-        }
-
-        HeaderFlags.prototype.setFlagged = function(flagged)
-        {
-            this.Flagged = flagged;
-        }
-
-        HeaderFlags.prototype.getRecent = function()
-        {
-            return this.Recent;
-        }
-
-        HeaderFlags.prototype.setRecent = function(recent)
-        {
-            this.Recent = recent;
-        }
-
-        function FlagsParser(headerObj)
-        {
-            this.Header = headerObj;
-        }
-
-        FlagsParser.prototype.parse = function()
-        {
-            var tmp = null;
-            if (typeof this.Header == 'string')
-            {
-                tmp = connector.unserialize(this.Header);
-            }
-            else
-            {
-                tmp = this.Header;
-            }
-
-            flags = new HeaderFlags();
-
-            if (tmp.Answered && tmp.Answered.match(/^A$/))
-            {
-                flags.setAnswered(1);
-                //if (tmp.Draft && tmp.Draft.match(/^X$/))
-                //{
-                //    flags.setDraft(1);
-                //}
-            }
-
-            if (tmp.Flagged && tmp.Flagged.match(/^F$/)){
-                flags.setFlagged(1);
-            }
-
-            if (tmp.Forwarded && tmp.Forwarded.match(/^F$/)){
-                flags.setAnswered(1);
-                //flags.setDraft(1);
-            }
-
-            if (tmp.Recent && tmp.Recent.match(/^R$/)){
-                flags.setRecent(1);
-            }
-
-            return flags;
-
-        }
+function local_messages() {
+    this.dbGears = null;
+    this.localServer = null;
+    this.store = null;
+}
+
+function charOrdA (a, b){
+    a = a[0].toLowerCase();
+    b = b[0].toLowerCase();
+    if (a>b) return 1;
+    if (a <b) return -1;
+    return 0;
+}
+function charOrdD(a, b){
+    a = a[0].toLowerCase();
+    b = b[0].toLowerCase();
+    if (a<b) return 1;
+    if (a>b) return -1;
+    return 0;
+}
+
+
+function HeaderFlags()
+{
+    this.Answered = 0;
+    //this.Draft = 0;
+    this.Flagged = 0;
+    this.Recent = 0;
+}
+
+HeaderFlags.prototype.getAnswered = function()
+{
+    return this.Answered;
+}
+
+HeaderFlags.prototype.setAnswered = function(answered)
+{
+    this.Answered = answered;
+}
+
+//HeaderFlags.prototype.getDraft = function()
+//{
+//    return this.Draft;
+//}
+
+HeaderFlags.prototype.setDraft = function(draft)
+{
+    this.Draft = draft;
+}
+
+HeaderFlags.prototype.getFlagged = function()
+{
+    return this.Flagged;
+}
+
+HeaderFlags.prototype.setFlagged = function(flagged)
+{
+    this.Flagged = flagged;
+}
+
+HeaderFlags.prototype.getRecent = function()
+{
+    return this.Recent;
+}
+
+HeaderFlags.prototype.setRecent = function(recent)
+{
+    this.Recent = recent;
+}
+
+function FlagsParser(headerObj)
+{
+    this.Header = headerObj;
+}
+
+FlagsParser.prototype.parse = function()
+{
+    var tmp = null;
+    if (typeof this.Header == 'string')
+    {
+	tmp = connector.unserialize(this.Header);
+    }
+    else
+    {
+	tmp = this.Header;
+    }
+
+    flags = new HeaderFlags();
+
+    if (tmp.Answered && tmp.Answered.match(/^A$/))
+    {
+	flags.setAnswered(1);
+    //if (tmp.Draft && tmp.Draft.match(/^X$/))
+    //{
+    //    flags.setDraft(1);
+    //}
+    }
+
+    if (tmp.Flagged && tmp.Flagged.match(/^F$/)){
+	flags.setFlagged(1);
+    }
+
+    if (tmp.Forwarded && tmp.Forwarded.match(/^F$/)){
+	flags.setAnswered(1);
+    //flags.setDraft(1);
+    }
+
+    if (tmp.Recent && tmp.Recent.match(/^R$/)){
+	flags.setRecent(1);
+    }
+
+    return flags;
+
+}
         
-	local_messages.prototype.installGears = function (){
-		temp = confirm(get_lang("To use local messages you have to install google gears. Would you like to install it now?"));
-		if (temp && typeof(preferences.googlegears_url) != 'undefined'){
-			if (is_ie)
-				location.href = preferences.googlegears_url + "/gears.exe";
-			else
-				location.href = preferences.googlegears_url + "/gears.xpi";
-			return false;
-		}
-		if (temp) {
-			location.href = "http://gears.google.com/?action=install&message="+
-				get_lang("To use local messages, install Google Gears")+"&return=" + document.location.href;
-		}
-		else return false;
-	}
-
-	local_messages.prototype.create_objects = function() {
-		if(window.google){
-		if (this.dbGears == null)
-			this.dbGears = google.gears.factory.create('beta.database');
-		if(this.localServer == null)
-			this.localServer = google.gears.factory.create('beta.localserver');
-		if(this.store == null)
-			this.store = this.localServer.createStore('test-store');
-		}
-	}
-
-	local_messages.prototype.init_local_messages = function(){ //starts only database operations
-		
-		if(this.dbGears==null || this.localServer==null || this.store == null)
-			this.create_objects();
-		
-		var db_in_other_use = true;
-		var start_trying = new Date().getTime();
-		while (db_in_other_use) {
-			try {
-				this.dbGears.open('database-test');
-				db_in_other_use = false;
-			} 
-			catch (ex) {
+local_messages.prototype.installGears = function (){
+    temp = confirm(get_lang("To use local messages you have to install google gears. Would you like to install it now?"));
+    if (temp && typeof(preferences.googlegears_url) != 'undefined'){
+	if (is_ie)
+	    location.href = preferences.googlegears_url + "/gears.exe";
+	else
+	    location.href = preferences.googlegears_url + "/gears.xpi";
+	return false;
+    }
+    if (temp) {
+	location.href = "http://gears.google.com/?action=install&message="+
+	get_lang("To use local messages, install Google Gears")+"&return=" + document.location.href;
+    }
+    else return false;
+}
+
+local_messages.prototype.create_objects = function() {
+    if(window.google){
+	if (this.dbGears == null)
+	    this.dbGears = google.gears.factory.create('beta.database');
+	if(this.localServer == null)
+	    this.localServer = google.gears.factory.create('beta.localserver');
+	if(this.store == null)
+	    this.store = this.localServer.createStore('test-store');
+    }
+}
+
+local_messages.prototype.init_local_messages = function(){ //starts only database operations
+		
+    if(this.dbGears==null || this.localServer==null || this.store == null)
+	this.create_objects();
+		
+    var db_in_other_use = true;
+    var start_trying = new Date().getTime();
+    while (db_in_other_use) {
+	try {
+	    this.dbGears.open('database-test');
+	    db_in_other_use = false;
+	}
+	catch (ex) {
 				if(new Date.getTime()-start_trying>10000) { //too much time trying, throw an exception
 					throw ex;
-				}
-			}
+	}
+    }
 		}
 			
-//		this.dbGears.open('database-test');
-		this.dbGears.execute('create table if not exists folder (folder text,uid_usuario int,unique(folder,uid_usuario))');
-		this.dbGears.execute('create table if not exists mail' +
-		' (mail blob,original_id int,original_folder text,header blob,timestamp int,uid_usuario int,unseen int,id_folder int,' + 
-		' ffrom text, subject text, fto text, cc text, body text, size int,unique (original_id,original_folder,uid_usuario))');
-		this.dbGears.execute('create table if not exists anexo' +
-		' (id_mail int,nome_anexo text,url text,pid int)');
-		this.dbGears.execute('create table if not exists folders_sync' +
-		' (id_folder text,folder_name text,uid_usuario int)');
-		this.dbGears.execute('create table if not exists msgs_to_remove (id_msg int,folder text,uid_usuario int)');
-		this.dbGears.execute('create index if not exists idx_user3 on mail (id_folder,uid_usuario,timestamp)');
-
-		//some people that used old version of local messages could not have the size column. If it's the first version
-		//with local messages you're using in expresso, this part of code can be removed
-		try {
-			this.dbGears.execute('alter table mail add column size int');
-		}catch(Exception) {
-			
-		}
-		var rs = this.dbGears.execute('select rowid,header from mail where size is null');
-		while(rs.isValidRow()) {
-			var temp = connector.unserialize(rs.field(1));
-			
-			this.dbGears.execute('update mail set size='+temp.Size+' where rowid='+rs.field(0));
-			rs.next();
-		}
-		//end of temporary code
-
-		try {
-                    this.dbGears.execute('begin transaction');
-                    this.dbGears.execute('alter table mail add column answered int');
-                    //this.dbGears.execute('alter table mail add column draft int');
-                    this.dbGears.execute('alter table mail add column flagged int');
-                    this.dbGears.execute('alter table mail add column recent int');
-                    //this.dbGears.execute('commit transaction');
-                    //transaction_ended = true;
-                    //if (transaction_ended){
-                    rs = null;
-                    rs = this.dbGears.execute('select rowid,header from mail');
-
-                    // Popular os valores das novas colunas.
-                    var tmp = null;
-                    //this.dbGears.execute('begin transaction');
-                    while(rs.isValidRow()) {
-                        //tmp = connector.unserialize(rs.field(1));
-                        parser = new FlagsParser(rs.field(1));
-                        flags = parser.parse();
-
-                        this.dbGears.execute('update mail set answered='+flags.getAnswered()+
-                            ',flagged='+flags.getFlagged()+',recent='+flags.getRecent()+
-                            //',draft='+flags.getDraft()+' where rowid='+rs.field(0));
-                            ' where rowid='+rs.field(0));
-
-			rs.next();
-                    }
-                    this.dbGears.execute('commit transaction');
-
-                    //tmp = null;
-
-                }catch(Exception) {
-                    this.dbGears.execute('rollback transaction');
-		}
-
-	}
-	
-	local_messages.prototype.drop_tables = function() {
-		this.init_local_messages();
-		var rs = this.dbGears.execute('select url from anexo');
-		while(rs.isValidRow()) {
-			this.store.remove(rs.field(0));
-			rs.next();
-		}
-		this.dbGears.execute('drop table folder');
-		this.dbGears.execute('drop table mail');
-		this.dbGears.execute('drop table anexo');
-		this.finalize();
-	}
-	
-	local_messages.prototype.insert_mail = function(msg_info,msg_header,anexos,folder) {
-		try {
-			this.init_local_messages();
-			var unseen = 0;
-			var login = msg_info.login;
-			var original_id = msg_info.msg_number;
-			var original_folder = msg_info.msg_folder;
-			
-			//This fields needs to be separeted to search.
-			var from = connector.serialize(msg_info.from);
-			var subject = msg_info.subject;
-			var body = msg_info.body;
-			var to = connector.serialize(msg_info.toaddress2);
-			var cc = connector.serialize(msg_info.cc);
-			var size = msg_header.Size;
-	
-			//do not duplicate this information
-			msg_info.from = null;
-			msg_info.subject = null;
-			msg_info.body = null;
-			msg_info.to = null;
-			msg_info.cc = null;
-			msg_header.Size=null;
-			//If the mail was archieved in the same date the user received it, the date cames with the time.
-			//here I solved it
-			if(msg_header.udate.indexOf(":")!=-1) {
-				msg_header.udate = msg_header.aux_date;
-			}
-			
-			/**
+    //		this.dbGears.open('database-test');
+    this.dbGears.execute('create table if not exists folder (folder text,uid_usuario int,unique(folder,uid_usuario))');
+    this.dbGears.execute('create table if not exists mail' +
+	' (mail blob,original_id int,original_folder text,header blob,timestamp int,uid_usuario int,unseen int,id_folder int,' +
+	' ffrom text, subject text, fto text, cc text, body text, size int,unique (original_id,original_folder,uid_usuario))');
+    this.dbGears.execute('create table if not exists anexo' +
+	' (id_mail int,nome_anexo text,url text,pid int)');
+    this.dbGears.execute('create table if not exists folders_sync' +
+	' (id_folder text,folder_name text,uid_usuario int)');
+    this.dbGears.execute('create table if not exists msgs_to_remove (id_msg int,folder text,uid_usuario int)');
+    this.dbGears.execute('create index if not exists idx_user3 on mail (id_folder,uid_usuario,timestamp)');
+
+    //some people that used old version of local messages could not have the size column. If it's the first version
+    //with local messages you're using in expresso, this part of code can be removed
+    try {
+	this.dbGears.execute('alter table mail add column size int');
+    }catch(Exception) {
+			
+    }
+    var rs = this.dbGears.execute('select rowid,header from mail where size is null');
+    while(rs.isValidRow()) {
+	var temp = connector.unserialize(rs.field(1));
+			
+	this.dbGears.execute('update mail set size='+temp.Size+' where rowid='+rs.field(0));
+	rs.next();
+    }
+    //end of temporary code
+
+    try {
+	this.dbGears.execute('begin transaction');
+	this.dbGears.execute('alter table mail add column answered int');
+	//this.dbGears.execute('alter table mail add column draft int');
+	this.dbGears.execute('alter table mail add column flagged int');
+	this.dbGears.execute('alter table mail add column recent int');
+	//this.dbGears.execute('commit transaction');
+	//transaction_ended = true;
+	//if (transaction_ended){
+	rs = null;
+	rs = this.dbGears.execute('select rowid,header from mail');
+
+	// Popular os valores das novas colunas.
+	var tmp = null;
+	//this.dbGears.execute('begin transaction');
+	while(rs.isValidRow()) {
+	    //tmp = connector.unserialize(rs.field(1));
+	    parser = new FlagsParser(rs.field(1));
+	    flags = parser.parse();
+
+	    this.dbGears.execute('update mail set answered='+flags.getAnswered()+
+		',flagged='+flags.getFlagged()+',recent='+flags.getRecent()+
+		//',draft='+flags.getDraft()+' where rowid='+rs.field(0));
+		' where rowid='+rs.field(0));
+
+	    rs.next();
+	}
+	this.dbGears.execute('commit transaction');
+
+    //tmp = null;
+
+    }catch(Exception) {
+	this.dbGears.execute('rollback transaction');
+    }
+
+}
+	
+local_messages.prototype.drop_tables = function() {
+    this.init_local_messages();
+    var rs = this.dbGears.execute('select url from anexo');
+    while(rs.isValidRow()) {
+	this.store.remove(rs.field(0));
+	rs.next();
+    }
+    this.dbGears.execute('drop table folder');
+    this.dbGears.execute('drop table mail');
+    this.dbGears.execute('drop table anexo');
+    this.finalize();
+}
+	
+local_messages.prototype.insert_mail = function(msg_info,msg_header,anexos,folder) {
+    try {
+	this.init_local_messages();
+	var unseen = 0;
+	var login = msg_info.login;
+	var original_id = msg_info.msg_number;
+	var original_folder = msg_info.msg_folder;
+			
+	//This fields needs to be separeted to search.
+	var from = connector.serialize(msg_info.from);
+	var subject = msg_info.subject;
+	var body = msg_info.body;
+	var to = connector.serialize(msg_info.toaddress2);
+	var cc = connector.serialize(msg_info.cc);
+	var size = msg_header.Size;
+	
+	//do not duplicate this information
+	msg_info.from = null;
+	msg_info.subject = null;
+	msg_info.body = null;
+	msg_info.to = null;
+	msg_info.cc = null;
+	msg_header.Size=null;
+	//If the mail was archieved in the same date the user received it, the date cames with the time.
+	//here I solved it
+	if(msg_header.udate.indexOf(":")!=-1) {
+	    msg_header.udate = msg_header.aux_date;
+	}
+			
+	/**
 			 * The importance attribute can be empty, and javascript consider as null causing nullpointer.
 			 */
-			if((msg_header.Importance == null) ||  (msg_header.Importance == ""))
-				msg_header.Importance = "Normal";
-			
-			msg_header.aux_date = null; 
-			
-			var mail = connector.serialize(msg_info);
-			var header = connector.serialize(msg_header);
-	
-			var timestamp = msg_info.timestamp;
-			var id_folder;
-	
-			if((folder==null) || (folder=="local_root"))
-				folder = "Inbox";
-			else
-				folder = folder.substr(6);//take off the word "local_"
-			
-			var rs = this.dbGears.execute("select rowid from folder where folder=? and uid_usuario=?",[folder,account_id]);
-        		if(rs.isValidRow())
-				id_folder=rs.field(0);
-			else {
-				this.dbGears.execute("insert into folder (folder,uid_usuario) values (?,?)",["Inbox",account_id]);
-				id_folder = this.dbGears.lastInsertRowId;
-			}
-			
-			if(msg_info.Unseen=="U")
-				unseen = 1;
-
-                        //parse header
-                        parser = new FlagsParser(msg_header);
-                        flags = parser.parse();
-
-                        //insere o e-mail
-                        //this.dbGears.execute("insert into mail (mail,original_id,original_folder,header,timestamp,uid_usuario,unseen,id_folder,ffrom,subject,fto,cc,body,size) values (?,?,?,?,?,?,?,?,?,?,?,?,?,?)",[mail,original_id,original_folder,header,timestamp,login,unseen,id_folder,from,subject,to,cc,body,size]);
-                        this.dbGears.execute("insert into mail (mail,original_id,original_folder,header,timestamp,uid_usuario,unseen,id_folder,ffrom,subject,fto,cc,body,size,answered,flagged,recent) values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)",[mail,original_id,original_folder,header,timestamp,login,unseen,id_folder,from,subject,to,cc,body,size,flags.getAnswered(),flags.getFlagged(),flags.getRecent()]);
-			var call_back = function() {
-			}
-			this.store.capture(msg_info.url_export_file,call_back);
-			var id_mail = this.dbGears.lastInsertRowId;
-	
-			this.insert_attachments(id_mail,anexos);
-			this.finalize();
-			return true;
-		} catch (error) {
-			this.finalize();
-			return false;
-		}
-
-
-	}
-	
-	/**
+	if((msg_header.Importance == null) ||  (msg_header.Importance == ""))
+	    msg_header.Importance = "Normal";
+			
+	msg_header.aux_date = null;
+			
+	var mail = connector.serialize(msg_info);
+	var header = connector.serialize(msg_header);
+	
+	var timestamp = msg_info.timestamp;
+	var id_folder;
+	
+	if((folder==null) || (folder=="local_root"))
+	    folder = "Inbox";
+	else
+	    folder = folder.substr(6);//take off the word "local_"
+			
+	var rs = this.dbGears.execute("select rowid from folder where folder=? and uid_usuario=?",[folder,account_id]);
+	if(rs.isValidRow())
+	    id_folder=rs.field(0);
+	else {
+	    this.dbGears.execute("insert into folder (folder,uid_usuario) values (?,?)",["Inbox",account_id]);
+	    id_folder = this.dbGears.lastInsertRowId;
+	}
+			
+	if(msg_info.Unseen=="U")
+	    unseen = 1;
+
+	//parse header
+	parser = new FlagsParser(msg_header);
+	flags = parser.parse();
+
+	//insere o e-mail
+	//this.dbGears.execute("insert into mail (mail,original_id,original_folder,header,timestamp,uid_usuario,unseen,id_folder,ffrom,subject,fto,cc,body,size) values (?,?,?,?,?,?,?,?,?,?,?,?,?,?)",[mail,original_id,original_folder,header,timestamp,login,unseen,id_folder,from,subject,to,cc,body,size]);
+	this.dbGears.execute("insert into mail (mail,original_id,original_folder,header,timestamp,uid_usuario,unseen,id_folder,ffrom,subject,fto,cc,body,size,answered,flagged,recent) values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)",[mail,original_id,original_folder,header,timestamp,login,unseen,id_folder,from,subject,to,cc,body,size,flags.getAnswered(),flags.getFlagged(),flags.getRecent()]);
+	var call_back = function() {
+	}
+	this.store.capture(msg_info.url_export_file,call_back);
+	var id_mail = this.dbGears.lastInsertRowId;
+	
+	this.insert_attachments(id_mail,anexos);
+	this.finalize();
+	return true;
+    } catch (error) {
+	this.finalize();
+	return false;
+    }
+
+
+}
+	
+/**
 	 * check if ID is no from main tab, if it's from main returns false, else 
 	 * returns an array with all string in position 0, the mail id in position 1 
